namespace Eco.Mods.TechTree
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using Eco.Gameplay.Blocks;
    using Eco.Gameplay.Components;
    using Eco.Gameplay.Components.Auth;
    using Eco.Gameplay.DynamicValues;
    using Eco.Gameplay.Economy;
    using Eco.Gameplay.Housing;
    using Eco.Gameplay.Interactions;
    using Eco.Gameplay.Items;
    using Eco.Gameplay.Minimap;
    using Eco.Gameplay.Objects;
    using Eco.Gameplay.Players;
    using Eco.Gameplay.Property;
    using Eco.Gameplay.Skills;
    using Eco.Gameplay.Systems.TextLinks;
    using Eco.Gameplay.Pipes.LiquidComponents;
    using Eco.Gameplay.Pipes.Gases;
    using Eco.Gameplay.Systems.Tooltip;
    using Eco.Shared;
    using Eco.Shared.Math;
    using Eco.Shared.Localization;
    using Eco.Shared.Serialization;
    using Eco.Shared.Utils;
    using Eco.Shared.View;
    using Eco.Shared.Items;
    using Eco.Gameplay.Pipes;
    using Eco.World.Blocks;
    
    [Serialized]    
    [RequireComponent(typeof(PropertyAuthComponent))]
    [RequireComponent(typeof(MinimapComponent))]                
    public partial class DangerSignObject : 
        WorldObject    
    {

        static DangerSignObject()
        {
            WorldObject.AddOccupancy<DangerSignObject>(new List<BlockOccupancy>(){

                new BlockOccupancy(new Vector3i(0, 0, 0), typeof(SolidWorldObjectBlock)),
                }); 
        }
        public override string FriendlyName { get { return "Danger Sign"; } } 


        protected override void Initialize()
        {
             this.GetComponent<MinimapComponent>().Initialize("Misc");                                 
    }

    [Serialized]
    public partial class DangerSignItem :
        WorldObjectItem<DangerSignObject> 
    {
        public override string FriendlyName { get { return "Danger Sign"; } } 
        public override string Description  { get { return  ""; } }

        static DangerSignItem()
        {

        }

    }


    [RequiresSkill(typeof(PrimitiveMechanicsSkill), 2)]
    public partial class DangerSignRecipe : Recipe
    {
        public DangerSignRecipe()
        {
            this.Products = new CraftingElement[]
            {
                new CraftingElement<DangerSignItem>(),
            };

            this.Ingredients = new CraftingElement[]
            {
            	new CraftingElement<SteelItem>(2),   
            };
            SkillModifiedValue value = new SkillModifiedValue(20, PrimitiveMechanicsSpeedSkill.MultiplicativeStrategy, typeof(PrimitiveMechanicsSpeedSkill), Localizer.DoStr("craft time"));
            SkillModifiedValueManager.AddBenefitForObject(typeof(DangerSignRecipe), Item.Get<DangerSignItem>().UILink(), value);
            SkillModifiedValueManager.AddSkillBenefit(Item.Get<DangerSignItem>().UILink(), value);
            this.CraftMinutes = value;
            this.Initialize("Danger Sign", typeof(DangerSignRecipe));
            CraftingComponent.AddRecipe(typeof(WainwrightTableObject), this);
        }
    }
}
}